Subject: Re: bug#39799: 28.0.50; Most emoji sequences don’t render correctly

From: Eli Zaretskii <[email-masked]>
Date: Tue, 21 Sep 2021 19:50:00 +0300

> Date: Tue, 21 Sep 2021 19:23:41 +0300
> From: Eli Zaretskii <[email-masked]>
> Cc: [email-masked], [email-masked], [email-masked]
> 
>   The element at index C in the table, if non-nil, is a list of
>   composition rules of the form ([PATTERN PREV-CHARS FUNC] ...);
>   the rules must be specified in the descending order of PREV-CHARS
>   ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
>   values.
>   ^^^^^^
> 
> (I could find the code which enforces this, if necessary, but I
> clearly remember bumping into this in misc-lang.el, with Arabic
> composition rules, which is when I added the above to documentation.)
> 
> And emoji-zwj.el doesn't adhere to this condition.  If you reorder the
> rules as required above, does the problem go away (I cannot test this
> myself, as I don't have access to a system where color Emoji work in
> Emacs)?

Actually, ignore me: the above is for rules for the same character,
whereas emoji-zwj.el doesn't have such rules.

I will take a look at the code.